function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import List from './List';
import IIIFParser from '../services/iiif-parser';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';

var iiifParser = new IIIFParser();

var StructuredNav = function (_Component) {
  _inherits(StructuredNav, _Component);

  function StructuredNav(props) {
    _classCallCheck(this, StructuredNav);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.manifest = _this.props.manifest;
    return _this;
  }

  StructuredNav.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (this.props.clickedUrl) {
      this.handleItemClick(this.props.clickedUrl);
    }
  };

  StructuredNav.prototype.handleItemClick = function handleItemClick(id) {
    var player = this.props.player;

    var timeFragment = iiifParser.getMediaFragment(id);
    if (!timeFragment) {
      console.error("Error retrieving time fragment object from Canvas url in StructuredNav.js");
      return;
    }
    // Pause player (if not)
    if (!player.paused) {
      player.pause();
    }
    // Set the start time
    player.setCurrentTime(timeFragment.start);
    // Start the player
    player.play();
  };

  StructuredNav.prototype.render = function render() {
    if (this.manifest.structures) {
      return React.createElement(List, {
        items: this.manifest.structures
      });
    }
    return React.createElement(
      'p',
      null,
      'There are no structures in the manifest.'
    );
  };

  return StructuredNav;
}(Component);

StructuredNav.propTypes = process.env.NODE_ENV !== "production" ? {
  manifest: PropTypes.object.isRequired
} : {};

var mapStateToProps = function mapStateToProps(state) {
  return {
    clickedUrl: state.nav.clickedUrl,
    player: state.player
  };
};

export default connect(mapStateToProps)(StructuredNav);