import mockManifest from '../json/lunchroom-manners';

export function fetchManifest(url) {
  return fetch(url, { credentials: 'include' }).then(function (response) {
    if (response.ok) {
      return response.json();
    }
    throw new Error('Network request was not ok');
  }).then(function (json) {
    return json;
  }).catch(function (err) {
    console.log('Problem with the fetch operation', err);
    return { error: 'Network failure fetching the manifest' };
  });
}

// Mock API call
export function fetchLocalManifest() {
  return new Promise(function (resolve) {
    setTimeout(function () {
      resolve(mockManifest);
    }, 500);
  });
}