'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MediaElementContainer = require('./containers/MediaElementContainer');

var _MediaElementContainer2 = _interopRequireDefault(_MediaElementContainer);

var _StructuredNav = require('./components/StructuredNav');

var _StructuredNav2 = _interopRequireDefault(_StructuredNav);

var _ErrorMessage = require('./components/ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _reactRedux = require('react-redux');

var _actions = require('./actions');

var actions = _interopRequireWildcard(_actions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var App = function (_Component) {
  _inherits(App, _Component);

  function App() {
    _classCallCheck(this, App);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  App.prototype.componentDidMount = function componentDidMount() {
    var manifestUrl = this.getManifestUrl();
    if (manifestUrl === '') {
      return;
    }
    this.props.getRemoteManifest(manifestUrl);
  };

  App.prototype.getManifestUrl = function getManifestUrl() {
    var el = document.getElementById('avln-iiif-player-root');
    if (!el) {
      return '';
    }
    return el.getAttribute('data-manifest-url');
  };

  App.prototype.render = function render() {
    var _props$getManifest = this.props.getManifest,
        manifest = _props$getManifest.manifest,
        error = _props$getManifest.error;


    if (manifest) {
      return _react2.default.createElement(
        'section',
        null,
        _react2.default.createElement(_MediaElementContainer2.default, { manifest: manifest }),
        _react2.default.createElement(_StructuredNav2.default, { manifest: manifest })
      );
    }
    if (error) {
      return _react2.default.createElement(_ErrorMessage2.default, { message: error });
    }
    return _react2.default.createElement(
      'p',
      null,
      '...Loading'
    );
  };

  return App;
}(_react.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    getManifest: state.getManifest
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    getRemoteManifest: function getRemoteManifest(url) {
      return dispatch(actions.getRemoteManifest(url));
    }
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(App);
module.exports = exports['default'];