'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _List = require('./List');

var _List2 = _interopRequireDefault(_List);

var _iiifParser = require('../services/iiif-parser');

var _iiifParser2 = _interopRequireDefault(_iiifParser);

var _reactRedux = require('react-redux');

var _actions = require('../actions');

var actions = _interopRequireWildcard(_actions);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iiifParser = new _iiifParser2.default();

var ListItem = function ListItem(props) {
  var item = props.item;

  var childCanvases = iiifParser.getChildCanvases(item);
  var subMenu = item.items && item.items.length > 0 && childCanvases.length === 0 ? _react2.default.createElement(_List2.default, { items: item.items }) : null;

  var handleClick = function handleClick(e) {
    e.stopPropagation();
    e.preventDefault();
    props.navItemClick(e.target.href);
  };

  var renderListItem = function renderListItem() {
    var label = item.label || 'Canvas item with no label';

    if (childCanvases.length > 0) {
      return childCanvases.map(function (canvasItem) {
        return _react2.default.createElement(
          'a',
          { key: canvasItem.id, href: canvasItem.id, onClick: handleClick },
          label
        );
      });
    } else {
      return label;
    }
  };

  return _react2.default.createElement(
    'li',
    null,
    renderListItem(),
    subMenu
  );
};

ListItem.propTypes = process.env.NODE_ENV !== "production" ? {
  key: _propTypes2.default.string,
  item: _propTypes2.default.object.isRequired
} : {};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    navItemClick: function navItemClick(url) {
      return dispatch(actions.navItemClick(url));
    }
  };
};

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(ListItem);
module.exports = exports['default'];