'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _List = require('./List');

var _List2 = _interopRequireDefault(_List);

var _iiifParser = require('../services/iiif-parser');

var _iiifParser2 = _interopRequireDefault(_iiifParser);

var _reactRedux = require('react-redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var iiifParser = new _iiifParser2.default();

var StructuredNav = function (_Component) {
  _inherits(StructuredNav, _Component);

  function StructuredNav(props) {
    _classCallCheck(this, StructuredNav);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.manifest = _this.props.manifest;
    return _this;
  }

  StructuredNav.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (this.props.clickedUrl) {
      this.handleItemClick(this.props.clickedUrl);
    }
  };

  StructuredNav.prototype.handleItemClick = function handleItemClick(id) {
    var player = this.props.player;

    var timeFragment = iiifParser.getMediaFragment(id);
    if (!timeFragment) {
      console.error("Error retrieving time fragment object from Canvas url in StructuredNav.js");
      return;
    }
    // Pause player (if not)
    if (!player.paused) {
      player.pause();
    }
    // Set the start time
    player.setCurrentTime(timeFragment.start);
    // Start the player
    player.play();
  };

  StructuredNav.prototype.render = function render() {
    if (this.manifest.structures) {
      return _react2.default.createElement(_List2.default, {
        items: this.manifest.structures
      });
    }
    return _react2.default.createElement(
      'p',
      null,
      'There are no structures in the manifest.'
    );
  };

  return StructuredNav;
}(_react.Component);

StructuredNav.propTypes = process.env.NODE_ENV !== "production" ? {
  manifest: _propTypes2.default.object.isRequired
} : {};

var mapStateToProps = function mapStateToProps(state) {
  return {
    clickedUrl: state.nav.clickedUrl,
    player: state.player
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps)(StructuredNav);
module.exports = exports['default'];