'use strict';

exports.__esModule = true;
exports.fetchManifest = fetchManifest;
exports.fetchLocalManifest = fetchLocalManifest;

var _lunchroomManners = require('../json/lunchroom-manners');

var _lunchroomManners2 = _interopRequireDefault(_lunchroomManners);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function fetchManifest(url) {
  return fetch(url, { credentials: 'include' }).then(function (response) {
    if (response.ok) {
      return response.json();
    }
    throw new Error('Network request was not ok');
  }).then(function (json) {
    return json;
  }).catch(function (err) {
    console.log('Problem with the fetch operation', err);
    return { error: 'Network failure fetching the manifest' };
  });
}

// Mock API call
function fetchLocalManifest() {
  return new Promise(function (resolve) {
    setTimeout(function () {
      resolve(_lunchroomManners2.default);
    }, 500);
  });
}